// Script Name: Swimming_Fish_Rezzer.lsl
// Author: Anonymous
// FISH-O-MATIC Fish generator.  
//
//A fish swimming script for random motions.  Put the fish inside the rezzer object along with the rezzer script. Click the rezzer, Menu for height, width and fish to rez appears.  The fish will swim randomly around inside that area.
//

// Downloaded from : http://www.free-lsl-scripts.com/cgi/freescripts.plx?ID=907

// This program is free software; you can redistribute it and/or modify it.
// Additional Licenes may apply that prevent you from selling this code
// and these licenses may require you to publish any changes you make on request.
//
// There are literally thousands of hours of work in these scripts. Please respect
// the creators wishes and Copyright law and follow their license requirements.
//
// License information included herein must be included in any script you give out or use.
// Licenses may also be included in the script or comments by the original author, in which case
// the authors license must be followed, and  their licenses override any licenses outlined in this header.
//
// You cannot attach a license to any of these scripts to make any license more or less restrictive.
//
// All scripts by avatar Ferd Frederix, unless stated otherwise in the script, are licensed as Creative Commons By Attribution and Non-Commercial.
// Commercial use is NOT allowed - no resale of my scripts in any form.  
// This means you cannot sell my scripts but you can give them away if they are FREE.  
// Scripts by Ferd Frederix may be sold when included in a new object that actually uses these scripts. Putting my script in a prim and selling it on marketplace does not constitute a build.
// For any reuse or distribution, you must make clear to others the license terms of my works. This is done by leaving headers intact.
// See http://creativecommons.org/licenses/by-nc/3.0/ for more details and the actual license agreement.
// You must leave any author credits and any headers intact in any script you use or publish.
///////////////////////////////////////////////////////////////////////////////////////////////////
// If you don't like these restrictions and licenses, then don't use these scripts.
//////////////////////// ORIGINAL AUTHORS CODE BEGINS ////////////////////////////////////////////
// fish rezzer.lsl
// CATEGORY:Underwater
// DESCRIPTION:fish rezzer.lsl
// Author: anonymous

// THE AMAZING
// TERRA(tm) FISH-O-MATIC(tm) FISH GENERATOR!!


integer RADIUS_MAX = 9; 
integer HEIGHT_MAX = 18; 
float FREQ = 5; // how often to change target location

integer chanDlg;
integer chanFish = 10; // fish listen on this channel

integer numFish;
integer radius = 2; // radius around rezzer
integer height = 10; // max height of fish target -- meters relative to rezzer
integer lstn;

vector myPos;
vector target;


list fishTypes;

key owner;



vector chooseTarget()
{
    myPos = llGetPos();
    vector offset;
    vector thisTarget;
    offset.x = llFrand(2 * radius) - radius; // x/y offset can be negative
    offset.y = llFrand(2 * radius) - radius;
    offset.z = llFrand(height) + 0.5;
    thisTarget = myPos + offset;
    return thisTarget;
}


getFishTypes()
{
    fishTypes = [];
    integer i;
    numFish = llGetInventoryNumber(INVENTORY_OBJECT);
    for (i = 0; i < numFish; i++)
    {
        fishTypes += [llGetInventoryName(INVENTORY_OBJECT,i)];
    }
}

init()
{
    chanDlg = (integer)(llFrand(10000)+1000); // random chat channel to avoid interference
    owner = llGetOwner();
    if (lstn)
    {
        llListenRemove(lstn);
        lstn = 0;
    }
    lstn = llListen(chanDlg,"", owner, "");
    myPos = llGetPos();
    llOwnerSay("Click me to set the options.");
}

menu()
{
    string txt = "SET UP THE FISHIES!\n\tMax height: "+(string)height+"m above rezzer\n\tHorizontal radius: "+(string)radius+"m";
    
    list buttons = ["Radius -","Height -","DELETE","Radius +", "Height +"] + fishTypes;
    
    llDialog(owner,txt,buttons,chanDlg);
}

rezFish(string name)
{
    llOwnerSay("Rezzing 1 "+name+".");
    llRezObject(name, chooseTarget(), ZERO_VECTOR, ZERO_ROTATION, 0);
    llSetTimerEvent(FREQ);
}

killFish()
{
    llOwnerSay("Deleting all nearby fish.");
    llSay(chanFish,"die");
    llSetTimerEvent(0);
}



default
{
    state_entry()
    {
        init();
    }
    
    on_rez(integer num)
    {
        llResetScript();
    }
    
    touch_start(integer num)
    {
        getFishTypes();
        integer i;
        key agent = llDetectedKey(i);
        if (agent == owner)
        {
            menu();
        }
    }
    
    listen(integer channel, string name, key id, string message)
    {
        if (message == "DELETE")
        {
            killFish();
        }
        else if (message == "Radius +") 
        {
            if (radius < RADIUS_MAX)
            {
                radius++;
            }
            else llOwnerSay("Radius is already at the maximum of "+(string)RADIUS_MAX+" meters.");
            menu();
            
        }
        else if (message == "Radius -")
        {
            if (radius > 0)
            {
                radius--;
            }
            menu();
        }
        else if (message == "Height +")
        {
            if (height < HEIGHT_MAX)
            {
                height++;
            }
            else llOwnerSay("Height is already at the maximum of "+(string)HEIGHT_MAX+" meters.");
            menu();
        }
        else if (message == "Height -")
        {
            if (height > 0)
            {
                height--;
            }
            menu();
        }
        else if (llGetInventoryType(message) >= INVENTORY_OBJECT) // returns -1 if object of that name doesn't exist
        {
            rezFish(message);
            menu();
        }
    }
    
    timer()
    {
        integer i;
        for (i = 0; i < numFish; i++)
        {
            vector t = chooseTarget();
            //target,<fish name>,<x>,<y>,<z>
            llSay(chanFish,"target,"+llList2String(fishTypes,i)+","+(string)t.x+","+(string)t.y+","+(string)t.z); // tell fish where to swarm
        }
        
    }
    
    
}// END //


